// Time-stamp: <2006-10-12 20:13:04 uijw>
#ifndef GENOTYPE_H__
#define GENOTYPE_H__

#include <vector>
#include <iostream>
#include <cassert>

template <typename T> char asAllele(T al);
template <typename T> char asInteger(T al);

typedef char gtype;

/** Convert an integer to a printable character            */
template <typename T>
char asAllele(T al)
{
  if (al==-1) return '?';
  else return  char(al+65);
}
/** convert a charater to an integer: A-0, B-1, C-2 ...    */
template <typename T>
char asInteger(T al)
{
  if (al=='?') return -1;
  else return  int(al)-65;
}
class genotype {
public:
  genotype(int loci): data(2*loci) {};
  genotype() {};
  gtype operator()(int locus, int allele) const {
    assert(allele==0||allele==1);
    return data[2*locus+allele];
  }
  gtype &operator()(int locus, int allele) {
    assert(allele==0||allele==1);
    return data[2*locus+allele];
  }
  gtype *operator[](int locus) {
    return &data[2*locus];
  } 
  const gtype *operator[](int locus) const {
    return &data[2*locus];
  } 
  /** the number of loci  */
  size_t nloci() const {
    return data.size()/2;
  }
  /** copy the first allele to second  */
  void copy0(int locus) {
    data[2*locus+1]=data[2*locus];
  }
  /** copy the second allele to first  */
  void copy1(int locus) {
    data[2*locus]=data[2*locus+1];
  }
 std::ostream &print(std::ostream &o) const;
private:
  std::vector<gtype> data;
};

std::ostream &operator<<(std::ostream &o, const genotype &g);

std::vector<genotype> readgenotypes(std::istream &is);

std::vector<int> nalleles(const std::vector<genotype> &d);

genotype convertStringsGenotypes(std::vector<std::string> &line,int loci);
#endif
