// Time-stamp: <2006-10-15 14:14:40 uijw>
// @file
#ifndef NEWTON_I_H__
#define NEWTON_I_H__

#include <vector>
#include <algorithm>
#include <numeric> // for accumulate
#include <cassert>


/** Calculate the e_symmetric functions              */
class e_sym_func {
public:  
  /** Construct from a vector of doubles             */
  e_sym_func(const std::vector<double> &x)
    :m(x.size()),e_(m+1) {
    calc(x);
  }
 
  ~e_sym_func(){};
  /** Calculate the symmetic functions               */
  void calc(const std::vector<double> &x);
  //  void calc_lx(const std::vector<double> &logx);
  /** Reset the symetric functions                  */
  void reset(const std::vector<double> &x) {
    m=x.size();
    e_.resize(m+1);
    calc(x);
  }
  /** return elementary symmetric function i  
   * i is from 0 to m                                */
  double operator()(int i) const {
    assert(i>=0&&i<=m);
    return e_[i];
  }

private:
  int m;
  std::vector<double> e_;
};

#endif
